package org.bsf.smartValueObject.demo;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

/**
 * Company.
 *
 */
public class CompanyVO implements Serializable {
    private Long id;
    private String name;
    private Date creationDate;
    private Collection subsidiaries = new ArrayList();

    private final SimpleDateFormat _dateFormat = new SimpleDateFormat( "dd/MM/yy" );

    public Long getId() {
        return id;
    }

    public void setId( Long id ) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName( String name ) {
        this.name = name;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate( Date creationDate ) {
        this.creationDate = creationDate;
    }

    public void addSubsidiary( SubsidiaryVO s ) {
        subsidiaries.add( s );
    }

    public void removeSubsidiary( SubsidiaryVO s ) {
        subsidiaries.remove( s );
    }

    public Collection getSubsidiaries() {
        return subsidiaries;
    }

    public Iterator subsidiaries() {
        return subsidiaries.iterator();
    }

    public String toString() {
        String dateAsString = "";

        if ( creationDate != null ) {
            // We don't want to return the time...
            dateAsString = _dateFormat.format( creationDate );
        }

        return "CompanyVO: id=" + id + " name=" + name + " creationdate=" + dateAsString;
    }
}
